]> arthur.barton.de Git - bup.git/blob - GNUmakefile
GNUmakefile: ensure DESTDIR and bup_shared_ldflags are defined
[bup.git] / GNUmakefile
1
2 MAKEFLAGS += --warn-undefined-variables
3 OUTPUT_OPTION = -MMD -MP -o $@
4
5 SHELL := bash
6 .DEFAULT_GOAL := all
7
8 clean_paths :=
9 generated_dependencies :=
10
11 # See config/config.vars.in (sets bup_python_config, among other things)
12 include config/config.vars
13 -include $(generated_dependencies)
14
15 pf := set -o pipefail
16
17 define isok
18   && echo " ok" || echo " no"
19 endef
20
21 # If ok, strip trailing " ok" and return the output, otherwise, error
22 define shout
23 $(if $(subst ok,,$(lastword $(1))),$(error $(2)),$(shell x="$(1)"; echo $${x%???}))
24 endef
25
26 sampledata_rev := $(shell dev/configure-sampledata --revision $(isok))
27 sampledata_rev := \
28   $(call shout,$(sampledata_rev),Could not parse sampledata revision)
29
30 current_sampledata := test/sampledata/var/rev/v$(sampledata_rev)
31
32 os := $(shell ($(pf); uname | sed 's/[-_].*//') $(isok))
33 os := $(call shout,$(os),Unable to determine OS)
34
35 # Satisfy --warn-undefined-variables
36 CFLAGS ?=
37 DESTDIR ?=
38 CPPFLAGS ?=
39 LDFLAGS ?=
40 TARGET_ARCH ?=
41
42 bup_shared_cflags := -O2 -Wall -Werror -Wformat=2
43 bup_shared_cflags := -Wno-unused-command-line-argument $(bup_shared_cflags)
44 bup_shared_cflags := -Wno-unknown-pragmas -Wsign-compare $(bup_shared_cflags)
45 bup_shared_cflags := -D_FILE_OFFSET_BITS=64 $(bup_shared_cflags)
46
47 bup_shared_ldflags :=
48
49 soext := .so
50 ifeq ($(os),CYGWIN)
51   soext := .dll
52 endif
53
54 ifdef TMPDIR
55   test_tmp := $(TMPDIR)
56 else
57   test_tmp := $(CURDIR)/test/tmp
58 endif
59
60 initial_setup := $(shell dev/update-checkout-info lib/bup/checkout_info.py $(isok))
61 initial_setup := $(call shout,$(initial_setup),update-checkout-info failed))
62 clean_paths += lib/bup/checkout_info.py
63
64 # Dependency changes here should be mirrored in Makefile
65 config/config.vars: configure config/configure config/configure.inc config/*.in
66         MAKE="$(MAKE)" ./configure
67
68 # On some platforms, Python.h and readline.h fight over the
69 # _XOPEN_SOURCE version, i.e. -Werror crashes on a mismatch, so for
70 # now, we're just going to let Python's version win.
71
72 helpers_cflags := $(bup_python_cflags) $(bup_shared_cflags)
73 helpers_ldflags := $(bup_python_ldflags) $(bup_shared_ldflags)
74
75 ifneq ($(strip $(bup_readline_cflags)),)
76   readline_cflags += $(bup_readline_cflags)
77   readline_xopen := $(filter -D_XOPEN_SOURCE=%,$(readline_cflags))
78   readline_xopen := $(subst -D_XOPEN_SOURCE=,,$(readline_xopen))
79   readline_cflags := $(filter-out -D_XOPEN_SOURCE=%,$(readline_cflags))
80   readline_cflags += $(addprefix -DBUP_RL_EXPECTED_XOPEN_SOURCE=,$(readline_xopen))
81   helpers_cflags += $(readline_cflags)
82 endif
83
84 helpers_ldflags += $(bup_readline_ldflags)
85
86 ifeq ($(bup_have_libacl),1)
87   helpers_cflags += $(bup_libacl_cflags)
88   helpers_ldflags += $(bup_libacl_ldflags)
89 endif
90
91 bup_ext_cmds := lib/cmd/bup-import-rdiff-backup lib/cmd/bup-import-rsnapshot
92
93 bup_deps := lib/bup/_helpers$(soext) lib/cmd/bup
94
95 all: dev/bup-exec dev/bup-python dev/python $(bup_deps) Documentation/all \
96   $(current_sampledata)
97
98 $(current_sampledata):
99         dev/configure-sampledata --setup
100
101 PANDOC ?= $(shell type -p pandoc)
102
103 ifeq (,$(PANDOC))
104   $(shell echo "Warning: pandoc not found; skipping manpage generation" 1>&2)
105   man_md :=
106 else
107   man_md := $(wildcard Documentation/*.md)
108 endif
109
110 man_roff := $(patsubst %.md,%.1,$(man_md))
111 man_html := $(patsubst %.md,%.html,$(man_md))
112
113 INSTALL=install
114 PREFIX=/usr/local
115 MANDIR=$(PREFIX)/share/man
116 DOCDIR=$(PREFIX)/share/doc/bup
117 BINDIR=$(PREFIX)/bin
118 LIBDIR=$(PREFIX)/lib/bup
119
120 dest_mandir := $(DESTDIR)$(MANDIR)
121 dest_docdir := $(DESTDIR)$(DOCDIR)
122 dest_bindir := $(DESTDIR)$(BINDIR)
123 dest_libdir := $(DESTDIR)$(LIBDIR)
124
125 install: all
126         $(INSTALL) -d $(dest_bindir) $(dest_libdir)/bup/cmd $(dest_libdir)/cmd \
127           $(dest_libdir)/web/static
128         test -z "$(man_roff)" || install -d $(dest_mandir)/man1
129         test -z "$(man_roff)" || $(INSTALL) -m 0644 $(man_roff) $(dest_mandir)/man1
130         test -z "$(man_html)" || install -d $(dest_docdir)
131         test -z "$(man_html)" || $(INSTALL) -m 0644 $(man_html) $(dest_docdir)
132         $(INSTALL) -pm 0755 lib/cmd/bup "$(dest_libdir)/cmd/bup"
133         $(INSTALL) -pm 0755 $(bup_ext_cmds) "$(dest_libdir)/cmd/"
134         cd "$(dest_bindir)" && \
135           ln -sf "$$($(bup_python) -c 'import os; print(os.path.relpath("$(abspath $(dest_libdir))/cmd/bup"))')"
136         set -e; \
137         $(INSTALL) -pm 0644 lib/bup/*.py $(dest_libdir)/bup/
138         $(INSTALL) -pm 0644 lib/bup/cmd/*.py $(dest_libdir)/bup/cmd/
139         $(INSTALL) -pm 0755 \
140                 lib/bup/*$(soext) \
141                 $(dest_libdir)/bup
142         $(INSTALL) -pm 0644 \
143                 lib/web/static/* \
144                 $(dest_libdir)/web/static/
145         $(INSTALL) -pm 0644 \
146                 lib/web/*.html \
147                 $(dest_libdir)/web/
148         if test -e lib/bup/checkout_info.py; then \
149             $(INSTALL) -pm 0644 lib/bup/checkout_info.py \
150                 $(dest_libdir)/bup/source_info.py; \
151         else \
152             ! grep -qF '$$Format' lib/bup/source_info.py; \
153             $(INSTALL) -pm 0644 lib/bup/source_info.py $(dest_libdir)/bup/; \
154         fi
155
156 embed_cflags := $(bup_python_cflags_embed) $(bup_shared_cflags) -I$(CURDIR)/src
157 embed_ldflags := $(bup_python_ldflags_embed) $(bup_shared_ldflags)
158
159 config/config.h: config/config.vars
160 clean_paths += config/config.h.tmp
161
162 cc_bin = $(CC) $(embed_cflags) $(CFLAGS) $^ $(embed_ldflags) $(LDFLAGS) -fPIE \
163   -I src $(OUTPUT_OPTION)
164
165 clean_paths += dev/python-proposed
166 generated_dependencies += dev/python-proposed.d
167 dev/python-proposed: dev/python.c src/bup/compat.c src/bup/io.c
168         rm -f dev/python
169         $(cc_bin)
170
171 clean_paths += dev/python
172 dev/python: dev/python-proposed
173         dev/validate-python $@-proposed
174         ln $@-proposed $@
175
176 clean_paths += dev/bup-exec
177 generated_dependencies += dev/bup-exec.d
178 dev/bup-exec: CFLAGS += -D BUP_DEV_BUP_EXEC=1
179 dev/bup-exec: lib/cmd/bup.c src/bup/compat.c src/bup/io.c
180         $(cc_bin)
181
182 clean_paths += dev/bup-python
183 generated_dependencies += dev/bup-python.d
184 dev/bup-python: CFLAGS += -D BUP_DEV_BUP_PYTHON=1
185 dev/bup-python: lib/cmd/bup.c src/bup/compat.c src/bup/io.c
186         $(cc_bin)
187
188 clean_paths += lib/cmd/bup
189 generated_dependencies += lib/cmd/bup.d
190 lib/cmd/bup: lib/cmd/bup.c src/bup/compat.c src/bup/io.c
191         $(cc_bin)
192
193 clean_paths += lib/bup/_helpers$(soext)
194 generated_dependencies += lib/bup/_helpers.d
195 lib/bup/_helpers$(soext): lib/bup/_helpers.c lib/bup/bupsplit.c
196         $(CC) $(helpers_cflags) $(CFLAGS) $^ \
197           $(helpers_ldflags) $(LDFLAGS) $(OUTPUT_OPTION)
198
199 test/tmp:
200         mkdir test/tmp
201
202 # MAKEFLAGS must not be in an immediate := assignment
203 parallel_opt = $(lastword $(filter -j%,$(MAKEFLAGS)))
204 get_parallel_n = $(patsubst -j%,%,$(parallel_opt))
205 maybe_specific_n = $(if $(filter -j%,$(parallel_opt)),-n$(get_parallel_n))
206 xdist_opt = $(if $(filter -j,$(parallel_opt)),-nauto,$(maybe_specific_n))
207
208 test: all test/tmp dev/python
209          if test yes = "$$(dev/python -c 'import xdist; print("yes")' 2>/dev/null)"; then \
210            (set -x; ./pytest $(xdist_opt);) \
211          else \
212            (set -x; ./pytest;) \
213          fi
214
215 stupid:
216         PATH=/bin:/usr/bin $(MAKE) test
217
218 check: test
219
220 distcheck: all
221         if test yes = $$(dev/python -c "import xdist; print('yes')" 2>/dev/null); then \
222           (set -x; ./pytest $(xdist_opt) -m release;) \
223         else \
224           (set -x; ./pytest -m release;) \
225         fi
226
227 long-test: export BUP_TEST_LEVEL=11
228 long-test: test
229
230 long-check: export BUP_TEST_LEVEL=11
231 long-check: check
232
233 .PHONY: check-both
234 check-both:
235         $(MAKE) clean && BUP_PYTHON_CONFIG=python3-config $(MAKE) check
236         $(MAKE) clean && BUP_PYTHON_CONFIG=python2.7-config $(MAKE) check
237
238 .PHONY: Documentation/all
239 Documentation/all: $(man_roff) $(man_html)
240
241 Documentation/substvars: $(bup_deps)
242         # FIXME: real temp file
243         set -e; bup_ver=$$(./bup version); \
244         echo "s,%BUP_VERSION%,$$bup_ver,g" > $@.tmp; \
245         echo "s,%BUP_DATE%,$$bup_ver,g" >> $@.tmp
246         mv $@.tmp $@
247
248 Documentation/%.1: Documentation/%.md Documentation/substvars
249         $(pf); sed -f Documentation/substvars $< \
250           | $(PANDOC) -s -r markdown -w man -o $@
251
252 Documentation/%.html: Documentation/%.md Documentation/substvars
253         $(pf); sed -f Documentation/substvars $< \
254           | $(PANDOC) -s -r markdown -w html -o $@
255
256 .PHONY: Documentation/clean
257 Documentation/clean:
258         cd Documentation && rm -f *~ .*~ *.[0-9] *.html substvars
259
260 # Note: this adds commits containing the current manpages in roff and
261 # html format to the man and html branches respectively.  The version
262 # is determined by "git describe --always".
263 .PHONY: update-doc-branches
264 update-doc-branches: Documentation/all
265         dev/update-doc-branches refs/heads/man refs/heads/html
266
267 # push the pregenerated doc files to origin/man and origin/html
268 push-docs: export-docs
269         git push origin man html
270
271 # import pregenerated doc files from origin/man and origin/html, in case you
272 # don't have pandoc but still want to be able to install the docs.
273 import-docs: Documentation/clean
274         $(pf); git archive origin/html | (cd Documentation && tar -xvf -)
275         $(pf); git archive origin/man | (cd Documentation && tar -xvf -)
276
277 clean: Documentation/clean
278         cd config && rm -rf finished bin config.var
279         cd config && rm -f \
280           ${CONFIGURE_DETRITUS} ${CONFIGURE_FILES} ${GENERATED_FILES}
281         rm -rf $(clean_paths) .pytest_cache
282         rm -f $(generated_dependencies)
283         find . -name __pycache__ -exec rm -rf {} +
284         if test -e test/mnt; then dev/cleanup-mounts-under test/mnt; fi
285         if test -e test/mnt; then rm -r test/mnt; fi
286         if test -e test/tmp; then dev/cleanup-mounts-under test/tmp; fi
287         # FIXME: migrate these to test/mnt/
288         if test -e test/int/testfs; \
289           then umount test/int/testfs || true; fi
290         rm -rf test/int/testfs test/int/testfs.img testfs.img
291         if test -e test/tmp; then dev/force-delete test/tmp; fi
292         dev/configure-sampledata --clean